Bullet = gideros.class(Sprite)

function Bullet:init(rotation,x,y,speed,timeSpawn)

	print("create bullet")

	local bulletImage = Bitmap.new(Texture.new("Images/bullet.png"))

	self.x = x
	self.originalX = x
	self.y = y
	self.originalY = y
	self.speed = speed
	self.timeSpawn = timeSpawn
	self.rotation = rotation
	self.bulletImage = bulletImage
	self.alive = true
	self:setPosition(self.x,self.y)
	self:set("rotation",rotation)
	self:addChild(bulletImage)
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)	
		
	stage:addChild(self)
	
end

function Bullet:onEnterFrame()
	self:update()
end

function Bullet:update()
	self.x = self.x + (math.cos((self.rotation-90) * math.pi/180) * self.speed)
	self.y = self.y + (math.sin((self.rotation-90) * math.pi/180) * self.speed)
	self:setPosition(self.x,self.y)
	
	if (self.x < -10 or self.x > 510 or self.y < -10) then
		--self:setPosition(self.originalX,self.originalY)
		--self.alive = false
		self:removeEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)	
		stage:removeChild(self)
		print("killed")
		
		--[[for i,v in pairs(self.scene.spritesWithVolume) do
			if(v==self) then
				table.remove(self.scene.spritesWithVolume, i)
			end
		end--]]
		
	end
end


function Bullet:getState()
	return self.alive
end

function Bullet:getTimeSpawn()
	return self.timeSpawn
end









